Loading...
Searching...
No Matches
casacore::TiledFileHelper Class Reference
tables package (libcasa_tables) » DataMan_module » DataMan_module_internal_classes

More...

`#include <TiledFileHelper.h>`

## Public Member Functions

| TiledFileHelper (const String &fileName, const IPosition &shape, DataType dtype, const TSMOption &, Bool writable, Bool bigEndian)
| Create a TiledFileHelper object.
| ~TiledFileHelper ()
| TiledFileHelper (const TiledFileHelper &)=delete
| Forbid copy constructor.
TiledFileHelper & | operator= (const TiledFileHelper &)=delete
| Forbid assignment.
virtual const TableDesc & | getDesc () const
| Get the table description needed for the hypercolumn description.
TSMFile * | file ()
virtual String | dataManagerType () const
| Return the class name.
virtual DataManager * | clone () const
| These functions are pure virtual, but not needed here.
virtual Bool | flush (AipsIO &, Bool)
| Flush and optionally fsync the data.
virtual void | create64 (rownr_t)
| Let the data manager initialize itself for a new table.
virtual TSMCube * | getHypercube (rownr_t)
virtual TSMCube * | getHypercube (rownr_t, IPosition &)
| Get the hypercube in which the given row is stored.
virtual void | readHeader (rownr_t, Bool)
| Let a derived class read the header info.
Public Member Functions inherited from casacore::TiledStMan
| TiledStMan ()
| Create a TiledStMan.
| TiledStMan (const String &hypercolumnName, uInt maximumCacheSizeMiB)
| Create a TiledStMan storage manager.
virtual | ~TiledStMan ()
| TiledStMan (const TiledStMan &)=delete
| Forbid copy constructor.
TiledStMan & | operator= (const TiledStMan &)=delete
| Forbid assignment.
virtual String | dataManagerName () const
| Get the name given to the storage manager.
void | setDataManagerName (const String &newHypercolumnName)
virtual Record | dataManagerSpec () const
| Return a record containing data manager specifications.
virtual Record | getProperties () const
| Get data manager properties that can be modified.
virtual void | setProperties (const Record &spec)
| Modify data manager properties.
void | setDataChanged ()
| Set the flag to "data has changed since last flush".
virtual void | setMaximumCacheSize (uInt nMiB)
| Set the maximum cache size (in MiB) in a non-persistent way.
uInt | maximumCacheSize () const
| Get the current maximum cache size (in MiB (MibiByte)).
uInt | cacheSize (rownr_t rownr) const
| Get the current cache size (in buckets) for the hypercube in the given row.
const IPosition & | hypercubeShape (rownr_t rownr) const
| Get the hypercube shape of the data in the given row.
const IPosition & | tileShape (rownr_t rownr) const
| Get the tile shape of the data in the given row.
uInt64 | bucketSize (rownr_t rownr) const
| Get the bucket size (in bytes) of the hypercube in the given row.
virtual Bool | canChangeShape () const
| Can the tiled storage manager handle changing array shapes?
virtual Bool | canAccessColumn () const
| Can the tiled storage manager access an entire column.
virtual Bool | hasMultiFileSupport () const
| The data manager supports use of MultiFile.
uInt | calcCacheSize (rownr_t rownr, const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath) const
| Calculate the cache size (in buckets) for accessing the hypercube containing the given row.
void | setCacheSize (rownr_t rownr, const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath, Bool forceSmaller)
| Set the cache size using the calcCacheSize function mentioned above.
void | setCacheSize (rownr_t rownr, uInt nbuckets, Bool forceSmaller)
| Set the cache size for accessing the hypercube containing the given row.
void | setHypercubeCacheSize (uInt hypercube, uInt nbuckets, Bool forceSmaller)
| Sets the cache size using the hypercube instead of the row number.
Bool | userSetCache (rownr_t rownr) const
| Determine if the user set the cache size (using setCacheSize).
void | emptyCaches ()
| Empty the caches used by the hypercubes in this storage manager.
void | showCacheStatistics (ostream &os) const
| Show the statistics of all caches used.
uInt64 | getLengthOffset (uInt64 nrPixels, Block< uInt > &dataOffset, Block< uInt > &localOffset, uInt &localTileLength) const
| Get the length of the data for the given number of pixels.
uInt | nrCoordVector () const
| Get the number of coordinate vectors.
rownr_t | nrow () const
| Get the nr of rows in this storage manager.
Bool | canAddRow () const
| Does the storage manager allow to add rows?
virtual IPosition | defaultTileShape () const
| Get the default tile shape.
uInt | nhypercubes () const
| Return the number of hypercubes.
virtual TSMCube * | singleHypercube ()
| Test if only one hypercube is used by this storage manager.
const TSMCube * | getTSMCube (uInt hypercube) const
| Get the given hypercube.
TSMCube * | getTSMCube (uInt hypercube)
const TSMCube * | getHypercube (rownr_t rownr) const
| Get the hypercube in which the given row is stored.
TSMCube * | makeTSMCube (TSMFile *file, const IPosition &cubeShape, const IPosition &tileShape, const Record &values, Int64 fileOffset=-1)
| Make the correct TSMCube type (depending on tsmOption()).
void | readTile (char *local, const Block< uInt > &localOffset, const char *external, const Block< uInt > &externalOffset, uInt nrpixels)
| Read a tile and convert the data to local format.
void | writeTile (char *external, const Block< uInt > &externalOffset, const char *local, const Block< uInt > &localOffset, uInt nrpixels)
| Write a tile after converting the data to external format.
TSMFile * | getFile (uInt sequenceNumber)
| Get the TSMFile object with the given sequence number.
virtual rownr_t | open64 (rownr_t nrrow, AipsIO &)
| Open the storage manager for an existing table.
virtual rownr_t | resync64 (rownr_t nrrow)
| Resync the storage manager with the new file contents.
virtual void | reopenRW ()
| Reopen all files used in this storage manager for read/write access.
virtual void | deleteManager ()
| The data manager will be deleted (because all its columns are requested to be deleted).
DataManagerColumn * | makeScalarColumn (const String &name, int dataType, const String &dataTypeID)
| Create a column in the storage manager on behalf of a table column.
DataManagerColumn * | makeDirArrColumn (const String &name, int dataType, const String &dataTypeID)
| Create a direct array column.
DataManagerColumn * | makeIndArrColumn (const String &name, int dataType, const String &dataTypeID)
| Create an indirect array column.
Bool | canReallocateColumns () const
| The TiledStMan wants to do reallocateColumn.
DataManagerColumn * | reallocateColumn (DataManagerColumn *column)
| Reallocate the column object if it is part of this data manager.
virtual void | setShape (rownr_t rownr, TSMCube *hypercube, const IPosition &shape, const IPosition &tileShape)
| Set the shape and tile shape of a hypercube.
void | checkCubeShape (const TSMCube *hypercube, const IPosition &cubeShape) const
| Check the shape to be set for a hypercube.
int | coordinateDataType (const String &columnName) const
| Get the data type of the coordinate column with the given name.
void | initCoordinates (TSMCube *hypercube)
| Initialize the new coordinates for the given cube.
const TSMDataColumn * | getDataColumn (uInt colnr) const
| Get pointer to data column object.
Public Member Functions inherited from casacore::DataManager
| DataManager ()
| Default constructor.
virtual | ~DataManager ()
| DataManager (const DataManager &)=delete
| The copy constructor cannot be used for this base class.
DataManager & | operator= (const DataManager &)=delete
| Assignment cannot be used for this base class.
void | dataManagerInfo (Record &info) const
| Add SEQNR and SPEC (the DataManagerSpec subrecord) to the info.
virtual Bool | isStorageManager () const
| Is the data manager a storage manager?
uInt | sequenceNr () const
| Get the (unique) sequence nr of this data manager.
uInt | ncolumn () const
| Get the nr of columns in this data manager (can be zero).
Bool | asBigEndian () const
| Have the data to be stored in big or little endian canonical format?
const TSMOption & | tsmOption () const
| Get the TSM option.
std::shared_ptr< MultiFileBase > | multiFile ()
| Get the MultiFile pointer (can be 0).
String | keywordName (const String &keyword) const
| Compose a keyword name from the given keyword appended with the sequence number (e.g.
String | fileName () const
| Compose a unique filename from the table name and sequence number.
ByteIO::OpenOption | fileOption () const
| Get the AipsIO option of the underlying file.
virtual Bool | isRegular () const
| Is this a regular storage manager?
Table & | table () const
| Get the table this object is associated with.
virtual Bool | canRemoveRow () const
| Does the data manager allow to delete rows?
virtual Bool | canAddColumn () const
| Does the data manager allow to add columns?
virtual Bool | canRemoveColumn () const
| Does the data manager allow to delete columns?
virtual Bool | canRenameColumn () const
| Does the data manager allow to rename columns?
virtual void | showCacheStatistics (std::ostream &) const
| Show the data manager's IO statistics.
DataManagerColumn * | createScalarColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a column in the data manager on behalf of a table column.
DataManagerColumn * | createDirArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a direct array column.
DataManagerColumn * | createIndArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create an indirect array column.
DataManager * | getClone () const
| Has the object already been cloned?
void | setClone (DataManager *clone) const
| Set the pointer to the clone.

## Private Attributes

TableDesc | itsDesc

## Additional Inherited Members

Static Public Member Functions inherited from casacore::TiledStMan
static IPosition | makeTileShape (const IPosition &hypercubeShape, Double tolerance=0.5, uInt64 maxNrPixelsPerTile=4 *1024 *1024)
| Derive the tile shape from the hypercube shape for the given number of pixels per tile.
static IPosition | makeTileShape (const IPosition &hypercubeShape, const Vector< double > &weight, const Vector< double > &tolerance, uInt64 maxNrPixelsPerTile=4 *1024 *1024)
Static Public Member Functions inherited from casacore::DataManager
static void | registerCtor (const String &type, DataManagerCtor func)
| Register a mapping of a data manager type to its static construction function.
static DataManagerCtor | getCtor (const String &dataManagerType)
| Get the "constructor" of a data manager (thread-safe).
static Bool | isRegistered (const String &dataManagerType)
| Test if a data manager is registered (thread-safe).
static DataManager * | unknownDataManager (const String &dataManagerType, const Record &spec)
| Serve as default function for theirRegisterMap, which catches all unknown data manager types.
Static Public Attributes inherited from casacore::DataManager
static rownr_t | MAXROWNR32
| Define the highest row number that can be represented as signed 32-bit.
Protected Member Functions inherited from casacore::TiledStMan
void | setPersMaxCacheSize (uInt nMiB)
| Set the persistent maximum cache size (in MiB).
uInt | getBindings (const Vector< String > &columnNames, PtrBlock< TSMColumn * > &colSet, Bool mustExist) const
| Get the bindings of the columns with the given names.
virtual void | setupCheck (const TableDesc &tableDesc, const Vector< String > &dataNames) const
| Function setup calls this function to allow the derived class to check specific information.
void | checkValues (const PtrBlock< TSMColumn * > &colSet, const Record &values) const
| Check if values are given in the record for all columns in the block.
void | checkCoordinates (const PtrBlock< TSMColumn * > &coordColSet, const IPosition &cubeShape, const Record &values) const
| Check if the coordinate values are correct.
void | checkShapeColumn (const IPosition &shape) const
| Check if the shapes of FixedShape data and coordinate columns match.
void | checkCoordinatesShapes (const TSMCube *hypercube, const IPosition &cubeShape) const
| Check if the cube shape matches that of defined coordinates.
void | checkAddHypercube (const IPosition &cubeShape, const Record &values) const
| Check if the hypercube to be added is correctly defined.
TSMCube * | makeHypercube (const IPosition &cubeShape, const IPosition &tileShape, const Record &values)
| Make a new TSMCube object.
Int | getCubeIndex (const Record &idValues) const
| Get the index of the hypercube with the given id-values.
rownr_t | addedNrrow (const IPosition &shape, uInt incrInLastDim) const
| Determine how many rows need to be added for an extension (in the last dimension) of a hypercube with the given shape.
Bool | flushCaches (Bool fsync)
| Flush the caches of all hypercubes.
AipsIO * | headerFileCreate ()
| Create the TSM header file.
AipsIO * | headerFileOpen ()
| Open the TSM header file.
void | headerFilePut (AipsIO &headerFile, uInt64 nrCube)
| Write the data into the header file.
uInt | headerFileGet (AipsIO &headerFile, rownr_t tabNrrow, Bool firstTime, Int extraNdim)
| Read the data from the header file.
void | headerFileClose (AipsIO *headerFile)
| Close the header file.
void | setup (Int extraNdim=-1)
| Set up the TiledStMan variables from the table description.
void | createFile (uInt index)
| Create a TSMFile object and store its pointer at the given index in the block.
int | arrayDataType (int dataType) const
| Convert the scalar data type to an array data type.
Protected Member Functions inherited from casacore::DataManager
void | decrementNcolumn ()
| Decrement number of columns (in case a column is deleted).
void | setEndian (Bool bigEndian)
| Tell the data manager if big or little endian format is needed.
void | setTsmOption (const TSMOption &tsmOption)
| Tell the data manager which TSM option to use.
void | setMultiFile (const std::shared_ptr< MultiFileBase > &mfile)
| Tell the data manager that MultiFile can be used.
void | throwDataTypeOther (const String &columnName, int dataType) const
| Throw an exception in case data type is TpOther, because the storage managers (and maybe other data managers) do not support such columns.
Protected Attributes inherited from casacore::TiledStMan
String | hypercolumnName_p
| The name of the hypercolumn.
rownr_t | nrrow_p
| The number of rows in the columns.
PtrBlock< TSMColumn * > | colSet_p
| The assembly of all columns.
PtrBlock< TSMDataColumn * > | dataCols_p
| The assembly of all data columns.
PtrBlock< TSMColumn * > | dataColSet_p
PtrBlock< TSMColumn * > | idColSet_p
| The assembly of all id columns.
PtrBlock< TSMColumn * > | coordColSet_p
| The assembly of all coordinate columns.
PtrBlock< TSMFile * > | fileSet_p
| The assembly of all TSMFile objects.
PtrBlock< TSMCube * > | cubeSet_p
| The assembly of all TSMCube objects.
uInt | persMaxCacheSize_p
| The persistent maximum cache size (in MiB) for a hypercube.
uInt | maxCacheSize_p
| The actual maximum cache size for a hypercube (in MiB).
uInt | nrdim_p
| The dimensionality of the hypercolumn.
uInt | nrCoordVector_p
| The number of vector coordinates.
IPosition | fixedCellShape_p
| The fixed cell shape.
Bool | dataChanged_p
| Has any data changed since the last flush?

## Detailed Description

Helper class for tiled access to an array in a file.

### Intended use:

Internal

### Review Status

Test programs:
  tTiledFileAccess

### Prerequisite

- Description of Tiled Storage Manager in module file Tables.h

### Synopsis

TiledFileHelper is a helper class for class TiledFileAccess. It sets up a table description containing one array column to make it possible to use the tiled storage manager to access an array in an arbitrary file.

### Motivation

This class was created to be able to read an image in a FITS file.

Definition at line 71 of file TiledFileHelper.h.

## Constructor & Destructor Documentation

## TiledFileHelper() [1/2]

casacore::TiledFileHelper::TiledFileHelper | ( | const String & | fileName,
|  | const IPosition & | shape,
|  | DataType | dtype,
|  | const TSMOption & | ,
|  | Bool | writable,
|  | Bool | bigEndian )

Create a TiledFileHelper object.

Tell if the data is stored in big or little endian canonical format.

References casacore::DataManager::fileName(), and casacore::shape().

Referenced by operator=(), and TiledFileHelper().

## ~TiledFileHelper()

casacore::TiledFileHelper::~TiledFileHelper | ( |  | ) |

## TiledFileHelper() [2/2]

casacore::TiledFileHelper::TiledFileHelper | ( | const TiledFileHelper & |  | ) |

delete

Forbid copy constructor.

References TiledFileHelper().

## Member Function Documentation

## clone()

virtual DataManager * casacore::TiledFileHelper::clone | ( |  | ) | const

virtual

These functions are pure virtual, but not needed here.

They throw an exception.

Implements casacore::DataManager.

## create64()

virtual void casacore::TiledFileHelper::create64 | ( | rownr_t | nrrow | ) |

virtual

Let the data manager initialize itself for a new table.

The default implementation calls the uInt version.

Reimplemented from casacore::DataManager.

## dataManagerType()

virtual String casacore::TiledFileHelper::dataManagerType | ( |  | ) | const

virtual

Return the class name.

Implements casacore::DataManager.

## file()

TSMFile * casacore::TiledFileHelper::file | ( |  | ) |

inline

Definition at line 90 of file TiledFileHelper.h.

References casacore::TiledStMan::fileSet_p.

## flush()

virtual Bool casacore::TiledFileHelper::flush | ( | AipsIO & | ios,
|  | Bool | fsync )

virtual

Flush and optionally fsync the data.

The AipsIO stream represents the main table file and can be used by virtual column engines to store SMALL amounts of data. It returns a True status if it had to flush (i.e. if data have changed).

Implements casacore::DataManager.

## getDesc()

virtual const TableDesc & casacore::TiledFileHelper::getDesc | ( |  | ) | const

virtual

Get the table description needed for the hypercolumn description.

Reimplemented from casacore::TiledStMan.

## getHypercube() [1/2]

virtual TSMCube * casacore::TiledFileHelper::getHypercube | ( | rownr_t |  | ) |

virtual

Implements casacore::TiledStMan.

## getHypercube() [2/2]

virtual TSMCube * casacore::TiledFileHelper::getHypercube | ( | rownr_t | rownr,
|  | IPosition & | position )

virtual

Get the hypercube in which the given row is stored.

It also returns the position of the row in that hypercube.

Implements casacore::TiledStMan.

## operator=()

TiledFileHelper & casacore::TiledFileHelper::operator= | ( | const TiledFileHelper & |  | ) |

delete

Forbid assignment.

References TiledFileHelper().

## readHeader()

virtual void casacore::TiledFileHelper::readHeader | ( | rownr_t | nrrow,
|  | Bool | firstTime )

virtual

Let a derived class read the header info.

This is used by the open and resync function.

Implements casacore::TiledStMan.

## Member Data Documentation

## itsDesc

TableDesc casacore::TiledFileHelper::itsDesc

private

Definition at line 108 of file TiledFileHelper.h.

The documentation for this class was generated from the following file:

- tables/DataMan/TiledFileHelper.h